/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 371 (Exercise B.3.8)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

n = 3;
nDates = 6;
study_Dates = zeros(nDates,1);
sigma = zeros(n,nDates);
rho = arrayinit(nDates|n|n,0);

/*
**> 1
*/

let x =  19991231;
let y =
           12.40             5.61            12.72;
let z[3,3] =   
          100.00            -5.89            -4.09 
           -5.89           100.00            -7.13 
           -4.09            -7.13           100.00; 
i = 1;
Study_Dates[i] = x;
sigma[.,i] = y;
rho[i,.,.] = z;

/*
**> 2
*/

let x = 20021231;
let y = 
           20.69             7.36            13.59; 
let z[3,3] =   
          100.00           -36.98            22.74 
          -36.98           100.00           -13.12 
           22.74           -13.12           100.00;
i = 2;
Study_Dates[i] = x;
sigma[.,i] = y;
rho[i,.,.] = z;

/*
**> 3
*/
 
let x = 20051230;
let y = 
            7.97             7.01            16.93;
let z[3,3] = 
          100.00            29.25            15.75 
           29.25           100.00            15.05 
           15.75            15.05           100.00;
i = 3;
Study_Dates[i] = x;
sigma[.,i] = y;
rho[i,.,.] = z;

/*
**> 4
*/
 
let x = 20071231;
let y = 
           12.94             5.50            14.54; 
let z[3,3] = 
          100.00           -25.76            31.91 
          -25.76           100.00             6.87 
           31.91             6.87           100.00; 
i = 4;
Study_Dates[i] = x;
sigma[.,i] = y;
rho[i,.,.] = z;

/*
**> 5
*/

let x = 20081231;
let y = 
           33.03             9.73            29.00;
let z[3,3] = 
          100.00           -16.26            47.31 
          -16.26           100.00             9.13 
           47.31             9.13           100.00;
i = 5;
Study_Dates[i] = x;
sigma[.,i] = y;
rho[i,.,.] = z;

/*
**> 6
*/

let x = 20101231;
let y = 
           16.73             6.88            16.93;
let z[3,3] = 
          100.00            15.31            64.13 
           15.31           100.00            15.46 
           64.13            15.46           100.00;

i = 6;
Study_Dates[i] = x;
sigma[.,i] = y;
rho[i,.,.] = z;

sigma = sigma / 100;
rho = rho / 100;

/*
**> Question 1
**
*/

print;
print "=====================  Question 1.a  =======================================";

Results = zeros(n+1,nDates);

t = 1;
do until t > nDates;
  cov = arraytomat(rho[t,.,.]) .* sigma[.,t] .* sigma[.,t]';
  sigma_t = sigma[.,t];
  x = 1 ./ sigma_t;
  x = x / sumc(x);
  vol = sqrt(x'cov*x);
  Results[.,t] = x|vol;
  t = t + 1;
endo;

print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 1.b  =======================================";

t = 1;
do until t > nDates;
  cov = arraytomat(rho[t,.,.]) .* sigma[.,t] .* sigma[.,t]';
  {x,vol,mr,rc,prc} = Compute_ERC_Portfolio(0,cov);
  Results[.,t] = x|vol;
  t = t + 1;
endo;

print ftosa(100*Results,"%lf",3,2);

print;
print "=====================  Question 1.d  =======================================";

t = 1;
rho_t = arraytomat(rho[t,.,.]);
sigma_t = sigma[.,t];

cov = rho_t .* sigma_t .* sigma_t';
x = 1 ./ sigma_t;
x = x / sumc(x);
vol = sqrt(x'cov*x);
inv_sigma = 1 ./ sigma_t;

rho_i = meanc(rho_t);
rho_bar = meanc(packr(vech(diagrv(rho_t,error(0)))));

vol2 = sqrt(n) * sqrt(1 + (n-1) * rho_bar) / sumc(1 ./ sigma_t);

mr2 = sigma_t .* rho_i .* sqrt(n) ./ sqrt(1 + (n - 1) * rho_bar);
rc2 = rho_i .* sqrt(n) ./ sqrt(1 + (n-1)*rho_bar) ./ sumc(1 ./ sigma_t); 
prc2 = rho_i ./ (1 + (n-1) * rho_bar);

{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);

print 100*(vol~vol2);

print 100*(mr~mr2);
print 100*(rc~rc2);
print 100*(prc~prc2);

print;
print "=====================  Question 1.e  =======================================";

Results = zeros(n,nDates);

t = 1;
do until t > nDates;
  sigma_t = sigma[.,t];
  x = 1 ./ sigma_t;
  x = x / sumc(x);
  cov = arraytomat(rho[t,.,.]) .* sigma[.,t] .* sigma[.,t]';
  {vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
  Results[.,t] = prc;
  t = t + 1;
endo;

print ftosa(100*Results,"%lf",3,2);

/*
**> Question 2
**
*/

let budgets[3,4] = 0.45 0.70 0.20 0.25
                   0.45 0.10 0.70 0.25
                   0.10 0.20 0.10 0.50;

Results = zeros(n,nDates);

print;
print "=====================  Question 2.a  =======================================";
    
i = 1;
do until i > cols(budgets);
  b = budgets[.,i];
  j = 1;
  do until j > nDates;
    cov = arraytomat(rho[j,.,.]) .* sigma[.,j] .* sigma[.,j]';
    {x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
    Results[.,j] = x;
    j = j + 1;
  endo;
  print ftosa(100*(b~Results),"%lf",3,2);
  i = i + 1;
endo;

print;
print "=====================  Question 2.b  =======================================";

SR = 0.40;
    
i = 1;
do until i > cols(budgets);
  b = budgets[.,i];
  j = 1;
  do until j > nDates;
    cov = arraytomat(rho[j,.,.]) .* sigma[.,j] .* sigma[.,j]';
    {x_rb,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
    Results[.,j] = SR * mr;
    j = j + 1;
  endo;
  print ftosa(100*(b~Results),"%lf",3,2);
  i = i + 1;
endo;

