/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 25
**
*/

new;
library rpb,pgraph;

cls;

let mu =    0.05 0.06 0.08 0.06;
let _sigma_ = 0.15 0.20 0.25 0.30;
n = rows(_Sigma_);
let rho =   1.00 
            0.10   1.00
            0.40   0.70   1.00
            0.50   0.40   0.80 1.00;
rho = xpnd(rho);
call invpd(rho);

Sigma = rho .* _sigma_ .* _sigma_';

r = 0.0;
SR = 0.25;
let x0 = 0.40 0.30 0.20 0.10;

tau = 1;
Gamma_ = tau * Sigma;
let P[1,4] = 1 0 0 0;
Omega = 0.05^2;
let Q =  0.0247 0.05 0.00;
nIters = rows(Q);

mu_bar = zeros(n,3);
i = 1;
do until i > nIters;
  {phi,mu_tilde,mu_bar[.,i]} = Compute_BL_Risk_Premium(x0,Sigma,SR,r,Gamma_,P,Q[i],Omega);
  i = i + 1;
endo;

mu_bar1 = mu_bar;

print "mu_bar = ";
print ftosa(100*mu_bar,"%lf",3,2);
print "--------------------------------------------------";

Gamma_ = eye(4) .* (tau * Sigma);
i = 1;
do until i > nIters;
  {phi,mu_tilde,mu_bar[.,i]} = Compute_BL_Risk_Premium(x0,Sigma,SR,r,Gamma_,P,Q[i],Omega);
  i = i + 1;
endo;

mu_bar2 = mu_bar;

print "mu_bar = ";
print ftosa(100*mu_bar,"%lf",3,2);
print "--------------------------------------------------";

mu_bar = mu_bar1~mu_bar[.,2 3];

tau = 1;
Gamma_ = tau * Sigma;
let P[1,4] = 0 1 -1 0;
Omega = 0.10^2;
let Q =  -0.0202 -0.04 0.02;
nIters = rows(Q);

mu_bar = zeros(n,3);
i = 1;
do until i > nIters;

  {phi,mu_tilde,mu_bar[.,i]} = Compute_BL_Risk_Premium(x0,Sigma,SR,r,Gamma_,P,Q[i],Omega);
  i = i + 1;
endo;

mu_bar1 = mu_bar;

print "mu_bar = ";
print ftosa(100*mu_bar,"%lf",3,2);
print "--------------------------------------------------";

Gamma_ = eye(4) .* (tau * Sigma);
i = 1;
do until i > nIters;
  {phi,mu_tilde,mu_bar[.,i]} = Compute_BL_Risk_Premium(x0,Sigma,SR,r,Gamma_,P,Q[i],Omega);
  i = i + 1;
endo;

mu_bar2 = mu_bar;

print "mu_bar = ";
print ftosa(100*mu_bar,"%lf",3,2);

mu_bar = mu_bar1~mu_bar[.,2 3];

