/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 45 (Table 1.8)
**
*/

new;
library rpb,pgraph;

cls;

let mu    = 0.08 0.08 0.05; 
let sigma = 0.20 0.21 0.10;

let rhoVectors = 0.80 0.70 0.90 0.80 0.90 0.80;
let sigma2     = 0.21 0.21 0.21 0.18 0.18 0.21;
let mu1        = 0.08 0.08 0.08 0.08 0.08 0.09;
n = rows(sigma);

target_vol = 0.15;

nIters = rows(rhoVectors);
all_MVO = zeros(n,nIters);

i = 1;
do until i > nIters;
  rho = rhoVectors[i];
  sigma[2] = sigma2[i];
  mu[1] = mu1[i];
  rho = diagrv(rho*ones(n,n),1.0);
  cov = rho .* sigma .* sigma';
  call invpd(cov);
  {all_MVO[.,i],mu_x,sigma_x,gamma_x,retcode} = Compute_MVO_Portfolio(mu,cov,ones(1,n),1,0,0,(-1~1).*ones(n,1),target_vol,2);
  i = i + 1;
endo;

print ftosa(100*all_MVO,"%lf",3,1);

  