/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 57 (Table 1.12)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.20 0.21 0.17 0.24 0.20 0.16;
mu = 0*sigma;
let rho =   1.00 
            0.40  1.00
            0.40  0.40  1.00
            0.50  0.50  0.50 1.00
            0.50  0.50  0.50 0.60 1.00
            0.50  0.50  0.50 0.60 0.60 1.00;
rho = xpnd(rho);
Cov = rho .* sigma .* sigma';
n = rows(mu);

Bounds = 0~1;

gamma_ = 0.0;
{x0,er0,risk0,gamma_star,retcode} = Compute_MVO_Portfolio(mu,cov,1,0,0,0,Bounds,gamma_,0);

{va,ve} = eighv(cov);
Lambda = diagrv(eye(n),va);
V = ve;

print ftosa(V*Lambda*V'-cov,"%lf",3,5);
print ftosa(V*inv(Lambda)*V'-invpd(cov),"%lf",3,5);

x1 = zeros(n,n);
er1 = zeros(n,1);
risk1 = zeros(n,1);

i = 1;
do until i > n;

  Lambda1 = Lambda;
  Lambda1[n-i+1,n-i+1] = 0;
  cov1 = V*Lambda1*V';
  {x1[.,i],er1[i],risk1[i],gamma_,retcode} = Compute_MVO_Portfolio(mu,cov1,1,0,0,0,Bounds,gamma_,0);

  i = i + 1;
endo;

print "------------------------------------------------------------------------------------------------------------------";
print ftosa(100*(x0~x1),"%lf",3,2);




