/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 101
**
*/

new;
library rpb,pgraph;

/*
**> The case when one risk budget is set to zero
**
*/

msym ".";

all_results = miss(zeros(3*2,4),0);

/*
**> Negative correlations
**
*/

let sigma = 0.20 0.10 0.05;
let rho =   1.00
            0.50   1.00
           -0.25  -0.25  1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
call invpd(cov);
let b = 0.50 0.50 0.00;
n = rows(cov);

i = 1;
{x,vol,mr,tr,rc} = Compute_RB_Vol(0,cov,b);
{vol,mr,tr,rc} = Compute_RC_Vol(x,cov);
all_results[1+(i-1)*3:i*3,1:3] = 100*(x~mr~rc)';
all_results[1+(i-1)*3+1,4] = 100*vol;

i = 2;
indx = selif(seqa(1,1,n), b ./= 0);
{x,vol,mr,tr,rc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov);
all_results[1+(i-1)*3:i*3,1:3] = 100*(x~mr~rc)';
all_results[1+(i-1)*3+1,4] = 100*vol;

cls;
print ftosa(all_results[1:3,.],"%lf",3,2);
print ftosa(all_results[4:6,.],"%lf",3,2);
print ftosa(all_results[4 1,.],"%lf",3,2);
