/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 135 (Duplication invariance property)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

let sigma[4,1] = 0.20 0.20 0.20 0.20;
m = rows(sigma);
rho = diagrv(0.00*ones(m,m),1.0);
cov1 = rho .* sigma .* sigma';

let sigma[5,1] = 0.20 0.20 0.20 0.20 0.20;
m = rows(sigma);
rho = diagrv(0.00*ones(m,m),1.0);
rho[m-1,m] = 1.0;
rho[m,m-1] = 1.0;
cov2 = rho .* sigma .* sigma';

{x1,vol1,mr1,rc1,prc1} = Compute_ERC_Portfolio(0,cov1);
{x2,vol2,mr2,rc2,prc2} = Compute_ERC_Portfolio(0,cov2);
let b3 = 0.25 0.25 0.25 0.125 0.125;
{x3,vol3,mr3,rc3,prc3} = Compute_RB_Portfolio(0,cov2,b3);

print ftosa(100*vol1,"%lf",3,2);
print ftosa(100*(x1~mr1~rc1~prc1),"%lf",3,2);

print ftosa(100*vol2,"%lf",3,2);
print ftosa(100*(x2~mr2~rc2~prc2),"%lf",3,2);

print ftosa(100*vol3,"%lf",3,2);
print ftosa(100*(x3~mr3~rc3~prc3),"%lf",3,2);
