/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 183 (Composition)
**
*/

new;
library rpb,pgraph;

cls;

PathName = "data//";
datFileName = Pathname $+ "sx5e-info";
loads info = ^datFileName;
datFileName = Pathname $+ "sx5e-weights";
Composition = loadd(datFileName);
datFileName = Pathname $+ "sx5e-prices";
Prices = loadd(datFileName);
nStocks = cols(Prices) - 2;

Weights = Composition[.,2:cols(Composition)]/100;

Rebalancing_Dates = Composition[.,1];
Rebalancing_Dates[1] = 19920101;
nRD = rows(Rebalancing_Dates);

Dates = Prices[.,1];
Index = Prices[.,2];
Prices = Prices[.,3:2+nStocks];

EndDate = 20120928;

Lag_CovMatrix = 260;
FileName = itos("Results\\sx5e-Weights-basic-",Lag_CovMatrix);
loadm Computed_Weights = ^FileName;

nAW = submat(getorders(Computed_Weights),1,0);

dt = 20120928;
indx = indnv(dt,Rebalancing_Dates);
Computed_Weights = array3d_get_y(Computed_Weights,indx)';
Computed_Weights = Computed_Weights[.,1:8];
Index_Weights = Weights[indx,.]';

Weights = Index_Weights~Computed_Weights;
Index_dt = (Index_Weights .> 1e-5);
Weights = selif(Weights,Index_dt);
Weights = miss(Weights .* (Weights .> 1e-3),0);

Info = selif(Info[.,3],Index_dt);
str = Info $~ ftosa(100*weights,"%lf",3,1);
num = (0 $+ info) ~ (100*weights);

indx = rev(sortind(Weights[.,1]));

// print str[indx,.];
print;

let fmt[10,3] = "%lf" 10 10 "%lf" 5 1
                "%lf" 5 1  "%lf" 5 1
                "%lf" 5 1  "%lf" 5 1
                "%lf" 5 1  "%lf" 5 1
                "%lf" 5 1  "%lf" 5 1;
call printfm(num[indx,.],0~ones(1,9),fmt);


