/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 257 (Table 5.4)
**
*/

new;
library rpb,pgraph;

cls;

_sqp_PrintIters = 0;
__output = 0;

n = 5;

if 1;
  let sigma = 0.10 0.40 0.30 0.10 0.30 
              0.20 0.20 0.20 0.50 0.20;
else;
  sigma = 0.20*ones(2*n,1);
endif;

let rho_inter = 1
                0.6 1
                0.6 0.6 1
                0.6 0.6 0.6 1;
let rho_intra = 0.80 0.70 0.65 0.90;
let indx_sector = 1 2 3 4 4 1 2 3 4 4;

factor = 1;
rho = Compute_Factor_Correlation(rho_inter/factor,rho_intra/factor,indx_sector);
cov = sigma .* sigma' .* rho;

/*
**> 1st Problem
**
*/

vol_target = 0.10;
{x,vol,mr,rc,prc} = Compute_ERC_LS(0,cov,vol_target);

print "--------------------------------";
print ftosa(seqa(1,1,n)~100*(x~mr~rc~prc),"%lf",3,2);
print ftosa(100*vol,"vol = %lf",3,2);

/*
**> 2nd Problem
**
*/

{x,vol,mr,rc,prc} = Compute_EMN_Portfolio(0,cov,vol_target,0);
print "--------------------------------";
print ftosa(seqa(1,1,n)~100*x~mr~rc~100*prc,"%lf",3,2);
print ftosa(100*vol,"vol = %lf",3,2);

results = seqa(1,1,n)~100*(x~rc~prc);

{x,vol,mr,rc,prc} = Compute_EMN_Portfolio(0,cov,vol_target,1);
print "--------------------------------";
print ftosa(seqa(1,1,n)~100*x~mr~rc~100*prc,"%lf",3,2);
print ftosa(100*vol,"vol = %lf",3,2);

results = results~100*(x~rc~prc);
print "--------------------------------";
print ftosa(results,"%lf",3,1);


