/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 292 (Table 6.9)
**
*/

new;
library rpb,pgraph;

cls;

datPathName = "Data\\";
datFileName = datPathName $+ "rfp-aw";

Begin_Date = 199201;
End_Date = 201206;

data = loadd(datFileName);
vnames = "" $+ getname(datFileName);
data = selif(data,(data[.,1] .>= Begin_Date) .and (data[.,1] .<= End_Date));

Dates = data[.,1];
nDates = rows(Dates);

let string Selected_Names[7,1] = "GDP" "IP" "CPI" "COMMO" "RR" "YC" "FXE";
indx_Factors = indsav(Selected_Names,vnames);
R_Factors = Data[.,indx_Factors];

let string Selected_Names[5,1] = "SP100" "EW" "MV" "MDP" "ERC";
indx_Indexes = indsav(Selected_Names,vnames);
nIndexes = rows(indx_Indexes);
R_Indexes = Data[.,indx_Indexes];

n = cols(R_Indexes);
m = cols(R_Factors);

let B[4,7] = 1 1 0 0 0 0 0
             0 0 1 1 0 0 0
             0 0 0 0 1 1 0
             0 0 0 0 0 0 1;

A_matrix = zeros(n,m);
prc_matrix = zeros(5,n);

i = 1;
do until i > n;
  
  y = R_Indexes[.,i];
  x = R_Factors;

  beta = y/x;
  A = beta';
  
  cov = 4 * vcx(y);
  Omega = 4 * vcx(x);
  D = cov - A*Omega*A';
  Sigma = A*Omega*A' + D;
  
  {vol,z,mr,rc,prc} = Compute_RC_Factor(1,Sigma,A,Omega,D);

  prc_matrix[.,i] = B*prc[1:m]|sumc(prc[n+1:m]);
  A_matrix[i,.] = A;
  
  i = i + 1;
endo;

print ftosa(100*prc_matrix,"%lf",3,1);


